SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT;
SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS;
SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION;
SET NAMES utf8;
SET @OLD_TIME_ZONE=@@TIME_ZONE;
SET TIME_ZONE='+00:00';
SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0;
SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0;
SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO';
SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0;

DROP TABLE IF EXISTS `service_ve_filters`;
CREATE TABLE `service_ve_filters` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` char(40) default '',
  `tariff_id` int(10) unsigned NOT NULL,
  `filter_group_id` int(11) NULL,
  `priority` int(10) unsigned NOT NULL,
  `store_stat` tinyint(4) NOT NULL default '0',
  `ve_conf` text NOT NULL default '',

  PRIMARY KEY  (`id`),
  KEY `service_ve_filters_filter_group_id` (`filter_group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_ve_uparams`;
CREATE TABLE `service_ve_uparams` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned NOT NULL,
  `access_type` char(15) NOT NULL,
  `ve_id` char(20) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `ve`;
CREATE TABLE `ve` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `veid` int(10) NOT NULL,
  `hn_id` int(10) NOT NULL,
  `hostname` char(30) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `hn`;
CREATE TABLE `hn` (
  `id` int(11) NOT NULL auto_increment,
  `hostname` varchar(200) NOT NULL,
  `ssh_priv_key` longtext NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `hostname` (`hostname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `service_tel_filters`;
CREATE TABLE `service_tel_filters` (
	`id` int(10) unsigned NOT NULL auto_increment,
	`title` char(40) default '',
	`tariff_id` int(10) unsigned NOT NULL,
	`filter_group_id` int(11) NULL,
	`priority` int(10) unsigned NOT NULL,
	`store_stat` tinyint(4) NOT NULL default '0',
	`src_number` char(20) NOT NULL,
	`dst_number` char(20) NOT NULL,
	`src_trunk` char(15) NOT NULL,
	`dst_trunk` char(15) NOT NULL,
	`in_call` tinyint(4) NOT NULL,
	`second_in_payment` numeric(5, 2) NOT NULL,
	`second_out_payment` numeric(5, 2) NOT NULL,
	PRIMARY KEY  (`id`),
	KEY `service_tel_filters_filter_group_id` (`filter_group_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_tel_stats`;
CREATE TABLE `service_tel_stats` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned NOT NULL,
  `filter_id` int(10) unsigned NOT NULL,
  `date_time` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `cost` float NOT NULL,
  `pbx` char(20) NOT NULL,
  `src_number` char(20) NOT NULL,
  `dst_number` char(20) NOT NULL,
  `src_trunk` char(15) NOT NULL,
  `dst_trunk` char(15) NOT NULL,
  `in_call` tinyint(1) NOT NULL,
  `duration` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_tel_uparams`;
CREATE TABLE `service_tel_uparams` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned NOT NULL,
  `access_type` char(15) NOT NULL,
  `tel_number` char(20) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_traff_filters`;
CREATE TABLE `service_traff_filters` (
	`id` int(11) NOT NULL auto_increment,
	`title` varchar(80) NOT NULL,
	`tariff_id` integer NOT NULL,
	`filter_group_id` integer,
	`priority` integer NOT NULL,
	`store_stat` integer NOT NULL,
	`network` varchar(20) NOT NULL,
	`netmask` varchar(20) NOT NULL,
	`port` int(11) NOT NULL,
	`proto` int(11) NOT NULL,
	`in_traff` tinyint(1) NOT NULL,
	`mb_cost` decimal(5,2) NOT NULL,
	`speed_in` varchar(30) default NULL,
	`speed_in_max` varchar(30) default NULL,
	`speed_out` varchar(30) default NULL,
	`speed_out_max` varchar(30) default NULL,
	`day_hours` varchar(150) default NULL,
	`week_days` varchar(60) default NULL,
	`month_days` varchar(180) default NULL,
	`year_months` varchar(120) default NULL,
  PRIMARY KEY  (`id`),
  KEY `service_traff_filters_tariff_id` (`tariff_id`),
  KEY `service_traff_filters_filter_group_id` (`filter_group_id`),
  CONSTRAINT `tariff_id_refs_id_73853e6188775365` FOREIGN KEY (`tariff_id`) REFERENCES `tariffs` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_traff_stats`;
CREATE TABLE `service_traff_stats` (
	`id` integer AUTO_INCREMENT NOT NULL PRIMARY KEY,
	`client_id` integer NOT NULL,
	`date_time` datetime NOT NULL,
	`cost` double precision NOT NULL,
	`filter_id` integer NOT NULL,
	`addr` integer UNSIGNED,
	`src_port` integer UNSIGNED,
	`dst_port` integer UNSIGNED,
	`bytes` integer UNSIGNED NOT NULL,
	`proto` integer UNSIGNED,
	`in_traff` bool NOT NULL,
	KEY `service_traff_stats_client_id` (`client_id`),
	CONSTRAINT `client_id_refs_id_8c5b3c345e98ad6` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
CREATE index date_time ON service_traff_stats(date_time);


DROP TABLE IF EXISTS `service_traff_stats_day`;
CREATE TABLE `service_traff_stats_day` (
	`id` integer AUTO_INCREMENT NOT NULL PRIMARY KEY,
	`client_id` integer NOT NULL,
	`date_time` datetime NOT NULL,
	`cost` double precision NOT NULL,
	`filter_id` integer NOT NULL,
	`bytes` integer UNSIGNED NOT NULL,
	`in_traff` bool NOT NULL,
	KEY `service_traff_stats_day_client_id` (`client_id`),
	CONSTRAINT `client_id_refs_id_750db9bf9486f075` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_traff_stats_hour`;
CREATE TABLE `service_traff_stats_hour` (
	`id` integer AUTO_INCREMENT NOT NULL PRIMARY KEY,
	`client_id` integer NOT NULL,
	`date_time` datetime NOT NULL,
	`cost` double precision NOT NULL,
	`filter_id` integer NOT NULL,
	`bytes` integer UNSIGNED NOT NULL,
	`in_traff` bool NOT NULL,
	KEY `service_traff_stats_hour_clientid` (`client_id`),
	CONSTRAINT `client_id_refs_id_6c7560f6a04a41be` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_traff_stats_month`;
CREATE TABLE `service_traff_stats_month` (
	`id` integer AUTO_INCREMENT NOT NULL PRIMARY KEY,
	`client_id` integer NOT NULL,
	`date_time` datetime NOT NULL,
	`cost` double precision NOT NULL,
	`filter_id` integer NOT NULL,
	`bytes` integer UNSIGNED NOT NULL,
	`in_traff` bool NOT NULL,
	KEY `service_traff_stats_month_client_id` (`client_id`),
	CONSTRAINT `client_id_refs_id_5193baf98691f963` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;


DROP TABLE IF EXISTS `service_traff_uparams`;
CREATE TABLE `service_traff_uparams` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `client_id` int(10) unsigned NOT NULL,
  `access_type` char(15) NOT NULL default '',
  `ip` char(20) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `tariffs`;
CREATE TABLE `tariffs` (
	`id` int(11) NOT NULL auto_increment,
	`title` varchar(120) NOT NULL,
	`service_id` int(11) NOT NULL,
	`billing_period_id` integer NOT NULL,
	`activation_fee` numeric(10, 4) NOT NULL,
	`periodic_fee` numeric(10, 4) NOT NULL,
	`week_days` varchar(12) NOT NULL,
	PRIMARY KEY  (`id`),
	KEY `tariffs_service_id` (`service_id`),
	CONSTRAINT `service_id_refs_id_18d82cb7ea2f4621` FOREIGN KEY (`service_id`) REFERENCES `services` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `user_services`;
CREATE TABLE `user_services` (
  `id` int(11) NOT NULL auto_increment,
  `client_id` int(11) default NULL,
  `group_id` int(11) default NULL,
  `tariff_id` int(11) NOT NULL,
  `account_id` int(11) NOT NULL,
  `service_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `user_services_client_id` (`client_id`),
  KEY `user_services_group_id` (`group_id`),
  KEY `user_services_tariff_id` (`tariff_id`),
  KEY `user_services_account_id` (`account_id`),
  KEY `user_services_service_id` (`service_id`),
  CONSTRAINT `account_id_refs_id_1fd20b960ee4b64a` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`),
  CONSTRAINT `client_id_refs_id_7d820ed502f71ddd` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`),
  CONSTRAINT `group_id_refs_id_349731937cd2e01d` FOREIGN KEY (`group_id`) REFERENCES `clientgroups` (`id`),
  CONSTRAINT `service_id_refs_id_33e25632476cd216` FOREIGN KEY (`service_id`) REFERENCES `services` (`id`),
  CONSTRAINT `tariff_id_refs_id_1a622e94f1869810` FOREIGN KEY (`tariff_id`) REFERENCES `tariffs` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `clients`;
CREATE TABLE `clients` (
  `id` int(11) NOT NULL auto_increment,
  `login` varchar(60) NOT NULL,
  `password` varchar(20) NOT NULL,
  `lastname` varchar(20) NOT NULL,
  `firstname` varchar(20) NOT NULL,
  `middlename` varchar(20) NOT NULL,
  `photo` varchar(100) default NULL,
  `work_tel` varchar(50) default NULL,
  `mobile_tel` varchar(50) default NULL,
  `email` varchar(50) default NULL,
  `jabber` varchar(50) default NULL,
  `user_id` int(11) default NULL,
  `yu_name` varchar(90) default NULL,
  `yu_address` varchar(150) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `login` (`login`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `clientgroups`;
CREATE TABLE `clientgroups` (
  `id` int(11) NOT NULL auto_increment,
  `yu_name` varchar(90) default NULL,
  `yu_address` varchar(150) default NULL,
  `name` varchar(80) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `clientgroups_clients`;
CREATE TABLE `clientgroups_clients` (
  `id` int(11) NOT NULL auto_increment,
  `clientgroup_id` int(11) NOT NULL,
  `client_id` int(11) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `clientgroup_id` (`clientgroup_id`,`client_id`),
  KEY `client_id_refs_id_253ed6981dae19b6` (`client_id`),
  CONSTRAINT `client_id_refs_id_253ed6981dae19b6` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`),
  CONSTRAINT `clientgroup_id_refs_id_3b2378b7f88ab9d0` FOREIGN KEY (`clientgroup_id`) REFERENCES `clientgroups` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `accounts`;
CREATE TABLE `accounts` (
	`id` int(11) NOT NULL auto_increment,
	`name` varchar(30) NOT NULL,
	`blocked` int(11) NOT NULL,
	`balance` decimal(10,4) NOT NULL,
	`credit` decimal(10,4) NOT NULL,
	`client_id` int(11) default NULL,
	`group_id` int(11) default NULL,
	`type` int(11) NOT NULL,
	`postpaid` bool NOT NULL,
	`ext_owner_id` varchar(30),

	PRIMARY KEY  (`id`),
	KEY `accounts_client_id` (`client_id`),
	KEY `accounts_group_id` (`group_id`),
	CONSTRAINT `client_id_refs_id_2557b10c759443ce` FOREIGN KEY (`client_id`) REFERENCES `clients` (`id`),
	CONSTRAINT `group_id_refs_id_6f91099ebff0022c` FOREIGN KEY (`group_id`) REFERENCES `clientgroups` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `services`;
CREATE TABLE `services` (
  `id` int(11) NOT NULL auto_increment,
  `title` varchar(120) NOT NULL,
  `codename` varchar(120) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `codename` (`codename`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `fee_by_services`;
CREATE TABLE `fee_by_services` (
  `id` int(11) unsigned NOT NULL auto_increment,
  `tariffid` int(11) unsigned NOT NULL,
  `serviceid` int(11) unsigned NOT NULL,
  `perday` float NOT NULL,
  `permonth` float NOT NULL,
  `last_writeoff_day` timestamp NOT NULL default '0000-00-00 00:00:00',
  `last_writeoff_month` timestamp NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

DELIMITER ;;
DROP PROCEDURE IF EXISTS `cleanstats`;;
CREATE PROCEDURE `cleanstats`(IN startdate CHAR(20), IN enddate CHAR(20))
BEGIN
               DELETE FROM service_traff_stats WHERE date_time BETWEEN startdate AND enddate;
END ;;

DROP PROCEDURE IF EXISTS `sumstats_hour`;;
CREATE PROCEDURE `sumstats_hour`(IN i_date CHAR(20))
BEGIN
	DECLARE clientid_int, filterid_int, b INT;
	DECLARE sum_bytes BIGINT;
	DECLARE sum_cost DOUBLE;
	DECLARE in_traff_int tinyint(1);
	DECLARE cur_1 CURSOR FOR SELECT sum(bytes), sum(cost), client_id, filter_id, in_traff FROM service_traff_stats WHERE date_time BETWEEN i_date AND DATE_ADD(i_date, INTERVAL 1 hour) GROUP BY client_id, filter_id, in_traff;
	DECLARE CONTINUE HANDLER FOR NOT FOUND
		SET b=1;
	DELETE FROM service_traff_stats_hour WHERE date_time = i_date;
	OPEN cur_1;
	WHILE NOT b <=> 1 DO
		FETCH cur_1 INTO sum_bytes, sum_cost, clientid_int, filterid_int, in_traff_int;
		IF NOT b <=> 1 THEN
			INSERT INTO service_traff_stats_hour (id, date_time, bytes, client_id, filter_id, in_traff, cost)VALUES (NULL, i_date, sum_bytes, clientid_int, filterid_int, in_traff_int, sum_cost);
		END IF;
	END WHILE;
    CLOSE cur_1;
END;;



DROP PROCEDURE IF EXISTS `sumstats_day`;;
CREATE PROCEDURE `sumstats_day`(IN i_date CHAR(20))
BEGIN
	DECLARE clientid_int, filterid_int, b INT;
	DECLARE sum_bytes BIGINT;
	DECLARE sum_cost DOUBLE;
	DECLARE in_traff_int tinyint(1);
	DECLARE cur_1 CURSOR FOR SELECT sum(bytes), sum(cost), client_id, filter_id, in_traff FROM service_traff_stats WHERE date_time BETWEEN i_date AND DATE_ADD(i_date, INTERVAL 1 day) GROUP BY client_id, filter_id, in_traff;
	DECLARE CONTINUE HANDLER FOR NOT FOUND
		SET b=1;
	DELETE FROM service_traff_stats_day WHERE date_time = i_date;
	OPEN cur_1;
	WHILE NOT b <=> 1 DO
		FETCH cur_1 INTO sum_bytes, sum_cost, clientid_int, filterid_int, in_traff_int;
		IF NOT b <=> 1 THEN
			INSERT INTO service_traff_stats_day (id, date_time, bytes, client_id, filter_id, in_traff, cost)VALUES (NULL, i_date, sum_bytes, clientid_int, filterid_int, in_traff_int, sum_cost);
		END IF;
	END WHILE;
    CLOSE cur_1;
END;;

DROP PROCEDURE IF EXISTS `sumstats_month`;;
CREATE PROCEDURE `sumstats_month`(IN i_date CHAR(20))
BEGIN
	DECLARE clientid_int, filterid_int, b INT;
	DECLARE sum_bytes BIGINT;
	DECLARE sum_cost DOUBLE;
	DECLARE in_traff_int tinyint(1);
	DECLARE cur_1 CURSOR FOR SELECT sum(bytes), sum(cost), client_id, filter_id, in_traff FROM service_traff_stats WHERE date_time BETWEEN i_date AND DATE_ADD(i_date, INTERVAL 1 month) GROUP BY client_id, filter_id, in_traff;
	DECLARE CONTINUE HANDLER FOR NOT FOUND
		SET b=1;
	DELETE FROM service_traff_stats_month WHERE date_time = i_date;
	OPEN cur_1;
	WHILE NOT b <=> 1 DO
		FETCH cur_1 INTO sum_bytes, sum_cost, clientid_int, filterid_int, in_traff_int;
		IF NOT b <=> 1 THEN
			INSERT INTO service_traff_stats_month (id, date_time, bytes, client_id, filter_id, in_traff, cost)VALUES (NULL, i_date, sum_bytes, clientid_int, filterid_int, in_traff_int, sum_cost);
		END IF;
	END WHILE;
    CLOSE cur_1;
END;;


DROP PROCEDURE IF EXISTS `writeoff_day` ;;
CREATE PROCEDURE `writeoff_day`()
BEGIN
	DECLARE tariff_id, service_id, delta, b INT;
	DECLARE tariff_perday, fee_perday DOUBLE;
	DECLARE tariff_last_writeoff_day, fee_last_writeoff_day TIMESTAMP;
	DECLARE cur_t CURSOR FOR SELECT id, perday, last_writeoff_day FROM tariffs;
	DECLARE cur_fee_services CURSOR FOR SELECT tariffid, serviceid, perday, last_writeoff_day FROM fee_by_services;
	DECLARE CONTINUE HANDLER FOR NOT FOUND
		SET b=1;
	OPEN cur_t;
	WHILE NOT b <=> 1 DO
		FETCH cur_t INTO tariff_id, tariff_perday, tariff_last_writeoff_day;
		IF NOT b <=> 1 THEN
			IF tariff_last_writeoff_day = '0000-00-00 00:00:00' THEN
				SET delta = 1;
			ELSE
				SET delta = DATEDIFF(now(),tariff_last_writeoff_day);
			END IF;
			
			IF delta > 0 THEN
				UPDATE accounts SET balance=balance-delta*tariff_perday WHERE tariffid=tariff_id;
				UPDATE tariffs SET last_writeoff_day=now() WHERE id=tariff_id;
			END IF;
		END IF;
	END WHILE;
	CLOSE cur_t;
-- Writeoff services fee
	SET b = 0;
	OPEN cur_fee_services;
	WHILE b != 1 DO
		FETCH cur_fee_services INTO tariff_id, service_id, fee_perday, fee_last_writeoff_day;
		IF NOT b <=> 1 THEN
			IF fee_last_writeoff_day = '0000-00-00 00:00:00' THEN
				SET delta = 1;
			ELSE
				SET delta = DATEDIFF(now(), fee_last_writeoff_day);
			END IF;
			IF delta > 0 THEN
				UPDATE accounts SET balance=balance-delta*fee_perday WHERE tariffid=tariff_id;
			END IF;
		END IF;
	END WHILE;
	CLOSE cur_fee_services;
END ;;

DROP PROCEDURE IF EXISTS `writeoff_month` ;;
CREATE PROCEDURE `writeoff_month`()
BEGIN
	DECLARE tariff_id, service_id, delta, b INT;
	DECLARE tariff_permonth, fee_permonth DOUBLE;
	DECLARE tariff_last_writeoff_month, fee_last_writeoff_month TIMESTAMP;
	DECLARE cur_t CURSOR FOR SELECT id, permonth, last_writeoff_month FROM tariffs;
	DECLARE cur_fee_services CURSOR FOR SELECT tariffid, serviceid, permonth, last_writeoff_month FROM fee_by_services;
	DECLARE CONTINUE HANDLER FOR NOT FOUND
		SET b=1;
	OPEN cur_t;
	WHILE b != 1 DO
		FETCH cur_t INTO tariff_id, tariff_permonth, tariff_last_writeoff_month;
		IF NOT b <=> 1 THEN
			IF tariff_last_writeoff_month = '0000-00-00 00:00:00' THEN
				SET delta = 1;
			ELSE
				SET delta = PERIOD_DIFF(DATE_FORMAT(now(),'%Y%m'), DATE_FORMAT(tariff_last_writeoff_month,'%Y%m'));
			END IF;
			
			IF delta > 0 THEN
				UPDATE accounts SET balance=balance-delta*tariff_permonth WHERE tariffid=tariff_id;
				UPDATE tariffs SET last_writeoff_month=now() WHERE id=tariff_id;
			END IF;
		END IF;
	END WHILE;
	CLOSE cur_t;
-- Writeoff services fee
	SET b = 0;
	OPEN cur_fee_services;
	WHILE NOT b <=> 1 DO
		FETCH cur_fee_services INTO tariff_id, service_id, fee_permonth, fee_last_writeoff_month;
		IF NOT b <=> 1 THEN
			IF fee_last_writeoff_month = '0000-00-00 00:00:00' THEN
				SET delta = 1;
			ELSE
				SET delta = PERIOD_DIFF(DATE_FORMAT(now(),'%Y%m'), DATE_FORMAT(fee_last_writeoff_month,'%Y%m'));
			END IF;
			IF delta > 0 THEN
				UPDATE accounts SET balance=balance-delta*fee_permonth WHERE tariffid=tariff_id;
			END IF;
		END IF;
	END WHILE;
	CLOSE cur_fee_services;
END ;;


DELIMITER ;

SET TIME_ZONE=@OLD_TIME_ZONE;

SET SQL_MODE=@OLD_SQL_MODE;
SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS;
SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS;
SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT;
SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS;
SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION;
SET SQL_NOTES=@OLD_SQL_NOTES;

